/*
 * The MIT License
 *
 * Copyright 2013 Dra0211.
 *
 * Permission is hereby granted, free of charge, to any person obtaining a copy
 * of this software and associated documentation files (the "Software"), to deal
 * in the Software without restriction, including without limitation the rights
 * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 * copies of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included in
 * all copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
 * THE SOFTWARE.
 */
package kinugasa.util;

/**
 * フレームワークのバージョンと開発開始日のメモです.
 * <br>
 *
 * <br>
 * @version 1.0.0 - 2013/04/20_17:18:27<br>
 * @author Dra0211<br>
 */
public enum Versions {

	/** このバージョンはRPGのクラス構造の研究に使用しました. */
	RPG_TEST_6("2011/07/18_20:18"),
	/** このバージョンはRPGのクラス構造の研究に使用しました. */
	RPG_TEST_7("2011/05/02_15:34"),
	/** このバージョンはRPGのクラス構造の研究に使用しました. */
	RPG_TEST_8("2011/04/15_20:49"),
	/** このバージョンはRPGのクラス構造の研究に使用しました. */
	RPG_TEST_10("2011/08/02_02:51"),
	/** このバージョンはRPGのクラス構造の研究に使用しました. */
	RPG_TEST_14("2011/06/18_01:31"),
	/** このバージョンはRPGのクラス構造の研究に使用しました. */
	RPG_TEST_17("2011/10/09_19:15"),
	/** このバージョンはRPGのクラス構造の研究に使用しました. */
	RPG_TEST_18("2011/09/03_16:42"),
	/** このバージョンはRPGのクラス構造の研究に使用しました. */
	RPG_TEST_20("2011/10/02_14:42"),
	/** このバージョンはRPGのクラス構造の研究に使用しました. */
	RPG_TEST_21("2011/10/11_22:01"),
	/** このバージョンはRPGのクラス構造の研究に使用しました. */
	RPG_TEST_22("2011/11/20_11:28"),
	/** このバージョンはRPGのクラス構造の研究に使用しました. */
	RPG_TEST_23("2011/11/27_11:55"),
	/** このバージョンはRPGのクラス構造の研究に使用しました. */
	RPG_TEST_24("2011/12/15_18:20"),
	/** このバージョンはRPGのクラス構造の研究に使用しました. */
	RPG_TEST_25("2012/01/14_23:54"),
	/** このバージョンはRPGのクラス構造の研究に使用しました. */
	RPG_TEST_26("2012/02/18_18:50"),
	/** このバージョンはRPGのクラス構造の研究に使用しました. */
	RPG_TEST_27("2012/03/20_17:30"),
	/** このバージョンはSTGのクラス構造の研究に使用しました. */
	STG_TEST_2("2011/08/15_2:59"),
	/** このバージョンはSTGのクラス構造の研究に使用しました. */
	STG_TEST_3("2011/08/23_03:59"),
	/** このバージョンはSTGのクラス構造の研究に使用しました. */
	STG_TEST_4("2011/09/10_00:20"),
	/** このバージョンはSTGのクラス構造の研究に使用しました. */
	STG_TEST_5("2011/09/20_20:10"),
	/** このバージョンはSTGのクラス構造の研究に使用しました. */
	STG_TEST_9("2011/10/29_18:22"),
	/** このバージョンはSTGのクラス構造の研究に使用しました. */
	STG_TEST_12("2012/02/23_05:28"),
	/** このバージョンはSTGのクラス構造の研究に使用しました. */
	STG_TEST_13("2012/03/03_21:22"),
	/** 最初に作られた包括的なフレームワークです. */
	VERSION_041("2012/05/06_02:26"),
	/** イベントマネージャ、ゲームコントローラの入力をサポートしたバージョンです. */
	VERSION_042("2012/08/31_05:28"),
	/** フィールドマップの部分的なサポートと、コアAPIの設計を改良したバージョンです. */
	VERSION_043("2012/09/29_22:29"),
	/** ライセンス、ベクトル計算、シリアライズによるセーブをサポートしたバージョンです. */
	VERSION_044("2013/01/11_14:10"),
	/** 実行速度を高めるために改良したバージョンです. */
	VERSION_0441("2013/02/13_08:53"),
	/** バージョン管理をGITに変更し、公開に向けた調整を行ったバージョンです. */
	VERSION_045("2013/04/20_17_20");
	/** このプロジェクトの名前"KINUGASA"です. */
	public static final String PROJECT_NAME = "KINUGASA";
	/** このプロジェクトの名前"衣笠"です. */
	public static final String PROJECT_NAME_JPN = "衣笠";
	/** 私です. */
	public static final String AUTHOR = "Dra0211";
	/** 私のメールアドレスです. */
	public static final String MAIL_TO = "d0211@live.jp";
	/** 著作権の表記です. */
	public static final String COPY_RIGHT = "Copyright (c) 2013 " + AUTHOR + " All rights reserved.";
	/** 最新バージョンです. */
	public static final Versions LATEST = VERSION_045;
	/** 開発を開始した日付と時刻のメモです. */
	private String createdDate;
	
	/**
	 * バージョンを定義します.
	 *
	 * @param createdDate 作成開始F日時を適当な文字列で指定します.<br>
	 */
	private Versions(String createdDate) {
		this.createdDate = createdDate;
	}

	/**
	 * このバージョンの作成開始日時を取得します.
	 *
	 * @return 作成開始日時が分かる適当な文字列を返します.<br>
	 */
	public String getCreatedDate() {
		return createdDate;
	}
}
